function render(time)
    local config = getEntityById("Config")
    local inputTexture = getEntityById("InputTexture")
    local shaderPass0 = getEntityById("ShaderPass0")
    local material0 = shaderPass0.getMaterial()

    --local lut = getEntityById("faceTable")
    --if lutTexId == nil then
    --    lutTexId = lut.getTextureAtTime(time - config.startTime)
    --else
    --    lutTexId = lut.getTextureAtTimeReuse(time - config.startTime, lutTexId)
    --end

    local faceTexId = getEntityById("faceTexId")

    shaderPass0.setOutputTextureSize(config.outputWidth, config.outputHeight)

    shaderPass0.setInputTexture("inputTexture", inputTexture)
    shaderPass0.setInputTexture("blendTexture", faceTexId)
    local faceRect = getEntityById("FaceRect")
    local x1 = faceRect.x
    local y1 = faceRect.y
    local x2 = faceRect.z
    local y2 = faceRect.w

    material0.setVec2("baseTextureSize", config.outputWidth, config.outputHeight)
    local ratio = (y2 - y1) / (x2 - x1)
    local blendScale = 1
    local offset = 0
    local imageScale = 1.5
    local offset1 = 0
    if ratio < 1 then
        blendScale = (x2 - x1) / 500
        blendScale = blendScale * imageScale
        offset = ((x2 - x1) - (y2 - y1)) / 2
        offset1 = (x2 - x1) * (imageScale - 1)/2
        offset = offset + offset1
        material0.setVec2("blendOffset", x1 - offset1 , (config.outputHeight - y2) - offset)
    else
        blendScale = (y2 - y1) / 500
        blendScale = blendScale * imageScale
        offset =  ((y2 - y1)- (x2 - x1)) / 2
        offset1 = (y2 - y1) * (imageScale - 1)/2
        offset = offset + offset1
        material0.setVec2("blendOffset", x1 - offset , (config.outputHeight - y2) - offset1)
    end
    material0.setFloat("blendScale", blendScale)
    shaderPass0.render()

    return shaderPass0.getOutputTexture()
end