function render(time)
    local config = getEntityById("Config")
    local inputTexture = getEntityById("InputTexture")
    local shaderPass0 = getEntityById("ShaderPass0")
    local material0 = shaderPass0.getMaterial()
    local shaderPass1 = getEntityById("ShaderPass1")
    local material1 = shaderPass1.getMaterial()

    local mode = getEntityById("Mode")

    material0.setInt("mode", mode)
    material1.setInt("mode", mode)

    if mode == 0 then
        local position = getEntityById("KeyPosition")
        material0.setVec2("key_position", position.x, position.y)
        material1.setVec2("key_position", position.x, position.y)
    else
        local color = getEntityById("KeyColor")
        material0.setVec3("key_color", color.x, color.y, color.z)
        material1.setVec3("key_color", color.x, color.y, color.z)
    end

    local minThreshold = getEntityById("MinThreshold")
    local maxThreshold = getEntityById("MaxThreshold")
    local s = 4*maxThreshold
    material0.setFloat("min_threshold", minThreshold)
    material0.setFloat("max_threshold", (s*s*s)/4)

    local shadowRemovalIntensity = getEntityById("ShadowRemovalIntensity")

    shaderPass0.setOutputTextureSize(config.outputWidth, config.outputHeight)
    shaderPass1.setOutputTextureSize(config.outputWidth, config.outputHeight)

    shaderPass0.setInputTexture("inputTexture", inputTexture)
    shaderPass0.render()

    if shadowRemovalIntensity > 0.0 then
        material1.setFloat("intensity", shadowRemovalIntensity)

        shaderPass1.setInputTexture("origInputTexture", inputTexture)
        shaderPass1.setInputTexture("pass0Texture", shaderPass0.getOutputTexture())
        shaderPass1.render()

        return shaderPass1.getOutputTexture()
    else
        return shaderPass0.getOutputTexture()
    end
end