precision mediump float;
varying vec2 textureCoordinate;

uniform int blurStep;
uniform highp vec2 pixelOffset;
uniform sampler2D inputTexture;
void main() {
    vec4 blurCoordinates;
    vec4 currentColor = texture2D(inputTexture, textureCoordinate);
    mediump vec3 sum = currentColor.rgb;
    for (int i = 0; i < blurStep; i++) {
        blurCoordinates = vec4(textureCoordinate.xy - float(i + 1) * pixelOffset,
                               textureCoordinate.xy + float(i + 1) * pixelOffset);
        sum += texture2D(inputTexture, blurCoordinates.xy).rgb;
        sum += texture2D(inputTexture, blurCoordinates.zw).rgb;
    }
    gl_FragColor = vec4(sum * 1.0 / float(2 * blurStep + 1), currentColor.a);
}