precision mediump float;
varying vec2 textureCoordinate;
uniform float progress;
uniform sampler2D from;
uniform sampler2D to;

float easeInOutQuint(float t)
{
    return t<0.5 ? 16.0*t*t*t*t*t : 1.0+16.0*(--t)*t*t*t*t;
}

void main() {
    float process = easeInOutQuint(progress);
    if(textureCoordinate.x < process) {
        gl_FragColor = texture2D(to, textureCoordinate + vec2(1.0 - process, 0.0));
    } else {
        gl_FragColor = texture2D(from, textureCoordinate - vec2(process, 0.0));
    }
}