 precision mediump float;
 
 varying mediump vec2 textureCoordinate;
 
 uniform sampler2D inputTexture;
 uniform sampler2D mapTexture;  //hefeMap
 
 uniform float strength;

 void main() {
    vec4 sourceColor = texture2D(inputTexture, textureCoordinate.xy);
    vec3 textureColor = sourceColor.rgb;
    
    textureColor = vec3(
                 texture2D(mapTexture, vec2(textureColor.r, .16666)).r,
                 texture2D(mapTexture, vec2(textureColor.g, .5)).g,
                 texture2D(mapTexture, vec2(textureColor.b, .83333)).b);
    
    textureColor.rgb = mix(sourceColor.rgb, textureColor.rgb, strength);

    gl_FragColor = vec4(textureColor, 1.0);
 }