precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputTexture;
uniform sampler2D maskTexture;
uniform vec2 maskSize;

// 腐蚀
vec4 ErodeGrayUchar(int kSize)
{
	// mask取值范围0~127，需要标准化颜色值
	vec2 coordinate = vec2(textureCoordinate.x, 1.0 - textureCoordinate.y);
	vec4 maskColor = texture2D(maskTexture, coordinate) / 127.0 * 255.0;
	int sum = 0;
	int edge = (kSize - 1) / 2; // 处理不到的边界像素值数目
	vec2 coordOffset = 1.0 / maskSize;

	float tempColor = maskColor.r;
	if (maskColor.r > 0.0) {
		for (int j = 0; j < kSize; j++) {
			for (int i = 0; i < kSize; i++) {
				vec2 uv = coordinate + vec2(float(-edge + i) * coordOffset.x, float(-edge + j) * coordOffset.y);
				// mask取值范围0~127，需要标准化颜色值
				vec4 temp_maskColor = texture2D(maskTexture, uv) / 127.0 * 255.0;
				tempColor = min(tempColor, temp_maskColor.r);
			}
		}
	}
	return vec4(vec3(tempColor), maskColor.a);
}

void main() {
    int ksize = 3;
    vec4 maskColor = ErodeGrayUchar(ksize);
    vec4 textureColor = texture2D(inputTexture, textureCoordinate);

    gl_FragColor = vec4(textureColor.rgb, maskColor.r);
}